// DepictItCtl.cpp : Implementation of the CDepictItCtrl OLE control class.

#include "stdafx.h"
#include "DepictIt.h"
#include "DepictItCtl.h"
#include "DepictItPpg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


// Custom defines for drawing types.
#define DRAW_LINE          0
#define DRAW_SOLID_RECT    1
#define DRAW_HOLLOW_RECT   2
#define DRAW_ROUND_RECT    3
#define DRAW_ARC           4
#define DRAW_CHORD         5
#define DRAW_PIE           6
#define DRAW_ELLIPSE       7

// Custom defines for brush types.
#define BT_SOLID        0
#define BT_BDIAGONAL    1
#define BT_CROSS        2
#define BT_DIAGCROSS    3
#define BT_FDIAGONAL    4
#define BT_HORIZONTAL   5
#define BT_VERTICAL     6
#define BT_PATTERN      7

IMPLEMENT_DYNCREATE(CDepictItCtrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CDepictItCtrl, COleControl)
	//{{AFX_MSG_MAP(CDepictItCtrl)
	// NOTE - ClassWizard will add and remove message map entries
	//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG_MAP
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CDepictItCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CDepictItCtrl)
	DISP_PROPERTY_NOTIFY(CDepictItCtrl, "CircleSquare", m_circleSquare, OnCircleSquareChanged, VT_BOOL)
	DISP_PROPERTY_NOTIFY(CDepictItCtrl, "BrushType", m_brushType, OnBrushTypeChanged, VT_I4)
	DISP_PROPERTY_NOTIFY(CDepictItCtrl, "DrawType", m_drawType, OnDrawTypeChanged, VT_I4)
	DISP_PROPERTY_NOTIFY(CDepictItCtrl, "PenType", m_penType, OnPenTypeChanged, VT_I4)
	DISP_PROPERTY_NOTIFY(CDepictItCtrl, "PenWidth", m_penWidth, OnPenWidthChanged, VT_I4)
	DISP_PROPERTY_NOTIFY(CDepictItCtrl, "PenColor", m_penColor, OnPenColorChanged, VT_COLOR)
	DISP_PROPERTY_NOTIFY(CDepictItCtrl, "X1", m_x1, OnX1Changed, VT_I4)
	DISP_PROPERTY_NOTIFY(CDepictItCtrl, "X2", m_x2, OnX2Changed, VT_I4)
	DISP_PROPERTY_NOTIFY(CDepictItCtrl, "X3", m_x3, OnX3Changed, VT_I4)
	DISP_PROPERTY_NOTIFY(CDepictItCtrl, "X4", m_x4, OnX4Changed, VT_I4)
	DISP_PROPERTY_NOTIFY(CDepictItCtrl, "Y1", m_y1, OnY1Changed, VT_I4)
	DISP_PROPERTY_NOTIFY(CDepictItCtrl, "Y2", m_y2, OnY2Changed, VT_I4)
	DISP_PROPERTY_NOTIFY(CDepictItCtrl, "Y3", m_y3, OnY3Changed, VT_I4)
	DISP_PROPERTY_NOTIFY(CDepictItCtrl, "Y4", m_y4, OnY4Changed, VT_I4)
	DISP_STOCKFUNC_DOCLICK()
	DISP_STOCKFUNC_REFRESH()
	DISP_STOCKPROP_BACKCOLOR()
	DISP_STOCKPROP_FORECOLOR()
	DISP_STOCKPROP_ENABLED()
	//}}AFX_DISPATCH_MAP
	DISP_FUNCTION_ID(CDepictItCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CDepictItCtrl, COleControl)
	//{{AFX_EVENT_MAP(CDepictItCtrl)
	// NOTE - ClassWizard will add and remove event map entries
	//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CDepictItCtrl, 1)
	PROPPAGEID(CDepictItPropPage::guid)
END_PROPPAGEIDS(CDepictItCtrl)


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CDepictItCtrl, "DEPICTIT.DepictItCtrl.1",
	0x70a187e3, 0x8bff, 0x11d0, 0x98, 0x87, 0, 0xa0, 0x24, 0xda, 0x5f, 0xb)


/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CDepictItCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DDepictIt =
		{ 0x70a187e1, 0x8bff, 0x11d0, { 0x98, 0x87, 0, 0xa0, 0x24, 0xda, 0x5f, 0xb } };
const IID BASED_CODE IID_DDepictItEvents =
		{ 0x70a187e2, 0x8bff, 0x11d0, { 0x98, 0x87, 0, 0xa0, 0x24, 0xda, 0x5f, 0xb } };


/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwDepictItOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CDepictItCtrl, IDS_DEPICTIT, _dwDepictItOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CDepictItCtrl::CDepictItCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CDepictItCtrl

BOOL CDepictItCtrl::CDepictItCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegApartmentThreading to 0.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_DEPICTIT,
			IDB_DEPICTIT,
			afxRegApartmentThreading,
			_dwDepictItOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// CDepictItCtrl::CDepictItCtrl - Constructor

CDepictItCtrl::CDepictItCtrl()
{
	InitializeIIDs(&IID_DDepictIt, &IID_DDepictItEvents);

	// TODO: Initialize your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CDepictItCtrl::~CDepictItCtrl - Destructor

CDepictItCtrl::~CDepictItCtrl()
{
	// TODO: Cleanup your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CDepictItCtrl::OnDraw - Drawing function

void CDepictItCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
   long     liDistance; // The distance between two points.
   CBitmap  oUpArrow;   // A bitmap object.

   // Create a standard foreground and background brush, and a pen.  Only the 
   // foreground brush type can be changed to something other than solid.
   oBackBrush.CreateSolidBrush(TranslateColor(COleControl::GetBackColor(), 
NULL));

   switch (m_brushType)
   {
   case BT_SOLID:
      // Create a solid brush.
      oForeBrush.CreateSolidBrush(TranslateColor
(COleControl::GetForeColor(), 
NULL));
      break;
   case BT_BDIAGONAL:
      // Create a backward diagonal brush.
      oForeBrush.CreateHatchBrush(HS_BDIAGONAL, TranslateColor
(COleControl::GetForeColor(), NULL));
      break;
   case BT_CROSS:
      // Create a vertical & horizontal cross brush.
      oForeBrush.CreateHatchBrush(HS_CROSS, 
TranslateColor
(COleControl::GetForeColor(), NULL));
      break;
   case BT_DIAGCROSS:
      // Create a diagonal cross brush.
      oForeBrush.CreateHatchBrush(HS_DIAGCROSS, 
TranslateColor
(COleControl::GetForeColor(), NULL));
      break;
   case BT_FDIAGONAL:
      // Create a forward diagonal brush.
      oForeBrush.CreateHatchBrush(HS_FDIAGONAL, 
TranslateColor
(COleControl::GetForeColor(), NULL));
      break;
   case BT_HORIZONTAL:
      // Create a horizontal brush.
      oForeBrush.CreateHatchBrush(HS_HORIZONTAL, 
TranslateColor
(COleControl::GetForeColor(), NULL));
      break;
   case BT_VERTICAL:
      // Create a vertical brush.
      oForeBrush.CreateHatchBrush(HS_VERTICAL, 
TranslateColor
(COleControl::GetForeColor(), NULL));
      break;
   case BT_PATTERN:
      // Load the bitmap.
      oUpArrow.LoadBitmap(IDB_ARROW);

      // Create a pattern brush.
      oForeBrush.CreatePatternBrush(&oUpArrow);
      break;
   }

   oPen.CreatePen(m_penType, m_penWidth, TranslateColor(m_penColor));
   
   // Set some default colors.
   pdc->SelectObject(&oForeBrush);
   pdc->SelectObject(&oPen);

   // Fill in the background.
   pdc->FillRect(rcBounds, &oBackBrush);

   // Determine which kind of graphics primitive to create.
   switch (m_drawType)
   {
   case DRAW_LINE:
      // Move to the starting point, then draw a line.
      pdc->MoveTo(m_x1, m_y1);
      pdc->LineTo(m_x2, m_y2);
      break;
   case DRAW_SOLID_RECT:
      // Check to see if we want a square.
      if (m_circleSquare)
      {
         liDistance = abs(m_x1 - m_x2);
         m_y2 = m_y1 + liDistance;
      }

      // Draw a solid rectangle.
      pdc->Rectangle(m_x1, m_y1, m_x2, m_y2);
      break;
   case DRAW_HOLLOW_RECT:
      // Check to see if we want a square.
      if (m_circleSquare)
      {
         liDistance = abs(m_x1 - m_x2);
         m_y2 = m_y1 + liDistance;
      }

      // Draw a hollow rectangle. The only brush width is 1.
      pdc->FrameRect(CRect(m_x1, m_y1, m_x2, m_y2), &oForeBrush);
      break;
   case DRAW_ROUND_RECT:
      // Check to see if we want a square.
      if (m_circleSquare)
      {
         liDistance = abs(m_x1 - m_x2);
         m_y2 = m_y1 + liDistance;
      }

      // Verify that the ellipse parameters used to round
      // the corners are within tolerance.
      if (!m_x3 > 0)
         m_x3 = 1;
      if (!m_y3 > 0)
         m_y3 = 1;

      // Draw a rectangle with rounded corners.
      pdc->RoundRect(m_x1, m_y1, m_x2, m_y2, m_x3, m_y3);
      break;
   case DRAW_ARC:
      // Draw an arc.
      pdc->Arc(m_x1, m_y1, m_x2, m_y2, m_x3, m_y3, m_x4, m_y4);
      break;
   case DRAW_CHORD:
      // Draw a chord.
      pdc->Chord(m_x1, m_y1, m_x2, m_y2, m_x3, m_y3, m_x4, m_y4);
      break;
   case DRAW_PIE:
      // Draw a pie wedge.
      pdc->Pie(m_x1, m_y1, m_x2, m_y2, m_x3, m_y3, m_x4, m_y4);
      break;
   case DRAW_ELLIPSE:
      // Check to see if we want a circle.
      if (m_circleSquare)
      {
         liDistance = abs(m_x1 - m_x2);
         m_y2 = m_y1 + liDistance;
      }

      pdc->Ellipse(m_x1, m_y1, m_x2, m_y2);
      break;
   }
}


/////////////////////////////////////////////////////////////////////////////
// CDepictItCtrl::DoPropExchange - Persistence support

void CDepictItCtrl::DoPropExchange(CPropExchange* pPX)
{
   int   iWidth;  // Control Width
   int   iHeight; // Control Height

   // Perform some default actions.
   ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
   COleControl::DoPropExchange(pPX);

   // Get the control width and height.
   COleControl::GetControlSize(&iWidth, &iHeight);

   // Initialize the default pen color.
   liPenColor = 0x00000000;

   // Make our properties persistent
   PX_Long(pPX, "BrushType", m_brushType, 0);
   PX_Bool(pPX, "CircleSquare", m_circleSquare, FALSE);
   PX_Long(pPX, "DrawType", m_drawType, 0);
   PX_Color(pPX, "PenColor", m_penColor, OLE_COLOR(liPenColor));
   PX_Long(pPX, "PenType", m_penType, PS_SOLID);
   PX_Long(pPX, "PenWidth", m_penWidth, 1);
   PX_Long(pPX, "X1", m_x1, 0);
   PX_Long(pPX, "X2", m_x2, iWidth);
   PX_Long(pPX, "X3", m_x3, 0);
   PX_Long(pPX, "X4", m_x4, 0);
   PX_Long(pPX, "Y1", m_y1, 0);
   PX_Long(pPX, "Y2", m_y2, iHeight);
   PX_Long(pPX, "Y3", m_y3, 0);
   PX_Long(pPX, "Y4", m_y4, 0);
}


/////////////////////////////////////////////////////////////////////////////
// CDepictItCtrl::OnResetState - Reset control to default state

void CDepictItCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	// TODO: Reset any other control state here.
}


/////////////////////////////////////////////////////////////////////////////
// CDepictItCtrl::AboutBox - Display an "About" box to the user

void CDepictItCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_DEPICTIT);
	dlgAbout.DoModal();
}


/////////////////////////////////////////////////////////////////////////////
// CDepictItCtrl message handlers

void CDepictItCtrl::OnCircleSquareChanged() 
{
   // Make sure our color changes take hold.
   COleControl::Refresh();

   // Perform default action.
   SetModifiedFlag();
}

void CDepictItCtrl::OnBrushTypeChanged() 
{
   // Make sure our color changes take hold.
   COleControl::Refresh();

   // Perform default action.
   SetModifiedFlag();
}

void CDepictItCtrl::OnDrawTypeChanged() 
{
   // Verify that the drawing type is valid.
   if ((m_drawType < DRAW_LINE) | (m_drawType > DRAW_ELLIPSE))
      m_drawType = DRAW_LINE;

   // Make sure our color changes take hold.
   COleControl::Refresh();

   // Perform default action.
   SetModifiedFlag();
}

void CDepictItCtrl::OnPenTypeChanged() 
{
   // Make sure we have a valid pen type.
   if ((m_penType < PS_SOLID) | (m_penType > PS_INSIDEFRAME))
      m_penType = PS_SOLID;

   // Make sure our pen type changes take hold.
   COleControl::Refresh();

   // Perform default action.
   SetModifiedFlag();
}

void CDepictItCtrl::OnPenWidthChanged() 
{
   // Make sure we have a valid pen width.
   if (m_penWidth < 1)
      m_penWidth = 1;

   // Make sure our pen width changes take hold.
   COleControl::Refresh();

   // Perform default action.
   SetModifiedFlag();
}

void CDepictItCtrl::OnPenColorChanged() 
{
   // Make sure our color changes take hold.
   COleControl::Refresh();

   // Perform default action.
   SetModifiedFlag();
}

void CDepictItCtrl::OnX1Changed() 
{
   // Make sure our color changes take hold.
   COleControl::Refresh();

   // Perform default action.
   SetModifiedFlag();
}

void CDepictItCtrl::OnX2Changed() 
{
   // Make sure our color changes take hold.
   COleControl::Refresh();

   // Perform default action.
   SetModifiedFlag();
}

void CDepictItCtrl::OnX3Changed() 
{
   // Make sure our color changes take hold.
   COleControl::Refresh();

   // Perform default action.
   SetModifiedFlag();
}

void CDepictItCtrl::OnX4Changed() 
{
   // Make sure our color changes take hold.
   COleControl::Refresh();

   // Perform default action.
   SetModifiedFlag();
}

void CDepictItCtrl::OnY1Changed() 
{
   // Make sure our color changes take hold.
   COleControl::Refresh();

   // Perform default action.
   SetModifiedFlag();
}

void CDepictItCtrl::OnY2Changed() 
{
   // Make sure our color changes take hold.
   COleControl::Refresh();

   // Perform default action.
   SetModifiedFlag();
}

void CDepictItCtrl::OnY3Changed() 
{
   // Make sure our color changes take hold.
   COleControl::Refresh();

   // Perform default action.
   SetModifiedFlag();
}

void CDepictItCtrl::OnY4Changed() 
{
   // Make sure our color changes take hold.
   COleControl::Refresh();

   // Perform default action.
   SetModifiedFlag();
}
