// PButtonCtl.cpp : Implementation of the CPButtonCtrl OLE control class.

#include "stdafx.h"
#include "PButton.h"
#include "PButtonCtl.h"
#include "PButtonPpg.h"
#include "PButtonPropPage2.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CPButtonCtrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CPButtonCtrl, COleControl)
	//{{AFX_MSG_MAP(CPButtonCtrl)
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
	ON_MESSAGE(OCM_COMMAND, OnOcmCommand)
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CPButtonCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CPButtonCtrl)
	DISP_PROPERTY_NOTIFY(CPButtonCtrl, "ModalResult", m_modalResult, OnModalResultChanged, VT_I4)
	DISP_PROPERTY_NOTIFY(CPButtonCtrl, "OnOff", m_onOff, OnOnOffChanged, VT_BOOL)
	DISP_PROPERTY_NOTIFY(CPButtonCtrl, "StdButtonType", m_stdButtonType, OnStdButtonTypeChanged, VT_I4)
	DISP_PROPERTY_NOTIFY(CPButtonCtrl, "IconType", m_iconType, OnIconTypeChanged, VT_I4)
	DISP_PROPERTY_NOTIFY(CPButtonCtrl, "IconPosition", m_iconPosition, OnIconPositionChanged, VT_I4)
	DISP_STOCKPROP_CAPTION()
	DISP_STOCKPROP_ENABLED()
	DISP_STOCKPROP_FONT()
	//}}AFX_DISPATCH_MAP
	DISP_FUNCTION_ID(CPButtonCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CPButtonCtrl, COleControl)
	//{{AFX_EVENT_MAP(CPButtonCtrl)
	EVENT_STOCK_CLICK()
	EVENT_STOCK_KEYDOWN()
	EVENT_STOCK_KEYPRESS()
	EVENT_STOCK_KEYUP()
	EVENT_STOCK_MOUSEDOWN()
	EVENT_STOCK_MOUSEMOVE()
	EVENT_STOCK_MOUSEUP()
	EVENT_STOCK_DBLCLICK()
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CPButtonCtrl, 3)
	PROPPAGEID(CPButtonPropPage::guid)
	PROPPAGEID(CPButtonPropPage2::guid)
	PROPPAGEID(CLSID_CFontPropPage)
END_PROPPAGEIDS(CPButtonCtrl)


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CPButtonCtrl, "PBUTTON.PButtonCtrl.1",
	0x8a8e38a3, 0x8bf1, 0x11d0, 0x98, 0x87, 0, 0xa0, 0x24, 0xda, 0x5f, 0xb)


/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CPButtonCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DPButton =
		{ 0x8a8e38a1, 0x8bf1, 0x11d0, { 0x98, 0x87, 0, 0xa0, 0x24, 0xda, 0x5f, 0xb } };
const IID BASED_CODE IID_DPButtonEvents =
		{ 0x8a8e38a2, 0x8bf1, 0x11d0, { 0x98, 0x87, 0, 0xa0, 0x24, 0xda, 0x5f, 0xb } };


/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwPButtonOleMisc =
	OLEMISC_SIMPLEFRAME |
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CPButtonCtrl, IDS_PBUTTON, _dwPButtonOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CPButtonCtrl::CPButtonCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CPButtonCtrl

BOOL CPButtonCtrl::CPButtonCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegApartmentThreading to 0.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_PBUTTON,
			IDB_PBUTTON,
			afxRegApartmentThreading,
			_dwPButtonOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// CPButtonCtrl::CPButtonCtrl - Constructor

CPButtonCtrl::CPButtonCtrl()
{
	InitializeIIDs(&IID_DPButton, &IID_DPButtonEvents);

	EnableSimpleFrame();

	// TODO: Initialize your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CPButtonCtrl::~CPButtonCtrl - Destructor

CPButtonCtrl::~CPButtonCtrl()
{
	// TODO: Cleanup your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CPButtonCtrl::OnDraw - Drawing function

void CPButtonCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
   HICON   hIcon;   // Handle of the icon we'll display.
   int     iWidth;  // Control Width
   int     iHeight; // Control Height
   // Get the control width and height.
   COleControl::GetControlSize(&iWidth, &iHeight);

   // Calculate the right position of the icon.
   iWidth -= 36;

   // Perform default paint behavior.
   DoSuperclassPaint(pdc, rcBounds);

   // Load the requested bitmap.
   switch (m_iconType)
   {
   case 1:
      hIcon = LoadIcon(NULL, IDI_APPLICATION);
      break;
   case 2:
      hIcon = LoadIcon(NULL, IDI_HAND);
      break;
   case 3:
      hIcon = LoadIcon(NULL, IDI_QUESTION);
      break;
   case 4:
      hIcon = LoadIcon(NULL, IDI_EXCLAMATION);
      break;
   case 5:
      hIcon = LoadIcon(NULL, IDI_ASTERISK);
      break;
   case 6:
      hIcon = LoadIcon(NULL, IDI_WINLOGO);
      break;
   case 7:
      hIcon = LoadIcon(NULL, IDI_WARNING);
      break;
   case 8:
      hIcon = LoadIcon(NULL, IDI_ERROR);
      break;
   case 9:
      hIcon = LoadIcon(NULL, IDI_INFORMATION);
   }

   // Display the icon on screen.
   if (m_iconPosition == 0)
   {
      DrawIcon(pdc->m_hDC, 4, 4, hIcon);
   }
   else
   {
      DrawIcon(pdc->m_hDC, iWidth, 4, hIcon);
   }
}


/////////////////////////////////////////////////////////////////////////////
// CPButtonCtrl::DoPropExchange - Persistence support

void CPButtonCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

  // Make all of our properties persistent.
  PX_Bool(pPX, "OnOff", m_onOff, FALSE);
  PX_Long(pPX, "ModalResult", m_modalResult, mrNone);
  PX_Long(pPX, "StdButtonType", m_stdButtonType, 0);
  PX_Long(pPX, "IconType", m_iconType, 1);
  PX_Long(pPX, "IconPosition", m_iconPosition, 0);
}


/////////////////////////////////////////////////////////////////////////////
// CPButtonCtrl::OnResetState - Reset control to default state

void CPButtonCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

  //Modify the control property settings.
  COleControl::SetText("Button");
  COleControl::SetControlSize(75, 25);
}


/////////////////////////////////////////////////////////////////////////////
// CPButtonCtrl::AboutBox - Display an "About" box to the user

void CPButtonCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_PBUTTON);
	dlgAbout.DoModal();
}


/////////////////////////////////////////////////////////////////////////////
// CPButtonCtrl::PreCreateWindow - Modify parameters for CreateWindowEx

BOOL CPButtonCtrl::PreCreateWindow(CREATESTRUCT& cs)
{
	cs.lpszClass = _T("BUTTON");
	return COleControl::PreCreateWindow(cs);
}


/////////////////////////////////////////////////////////////////////////////
// CPButtonCtrl::IsSubclassedControl - This is a subclassed control

BOOL CPButtonCtrl::IsSubclassedControl()
{
	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CPButtonCtrl::OnOcmCommand - Handle command messages

LRESULT CPButtonCtrl::OnOcmCommand(WPARAM wParam, LPARAM lParam)
{
#ifdef _WIN32
	WORD wNotifyCode = HIWORD(wParam);
#else
	WORD wNotifyCode = HIWORD(lParam);
#endif

	// TODO: Switch on wNotifyCode here.

	return 0;
}


/////////////////////////////////////////////////////////////////////////////
// CPButtonCtrl message handlers

void CPButtonCtrl::OnModalResultChanged() 
{
  // We don't need to do anything here except set the modified flag.
  SetModifiedFlag();
}

void CPButtonCtrl::OnOnOffChanged() 
{
  //If the programmer set the OnOff property true, take appropriate action.
  if (m_onOff)
  {
    COleControl::SetText("On");    //Change the caption.
    m_SetOn = TRUE;                //Set an internal caption flag.
    m_modalResult = mrOn;          //Set the modal result value.
  }
  else
  {
    COleControl::SetText("Button");    //Restore default caption.
    m_SetOn = FALSE;                   //Turn our caption flag off.
    m_modalResult = mrNone;            //Use the default modal result.
  }

  SetModifiedFlag();                   //Perform the default action.
}

void CPButtonCtrl::OnStdButtonTypeChanged() 
{
  // Change the modal result and button caption to match the user selection.
  switch (m_stdButtonType)
  {
  case 0:
    m_modalResult = mrNone;
    COleControl::SetText("Button");
    break;
  case 1:
    m_modalResult = mrOK;
    COleControl::SetText("OK");
    break;
  case 2:
    m_modalResult = mrCancel;
    COleControl::SetText("Cancel");
    break;
  case 3:
    m_modalResult = mrAbort;
    COleControl::SetText("Abort");
    break;
  case 4:
    m_modalResult = mrRetry;
    COleControl::SetText("Retry");
    break;
  case 5:
    m_modalResult = mrIgnore;
    COleControl::SetText("Ignore");
    break;
  case 6:
    m_modalResult = mrYes;
    COleControl::SetText("Yes");
    break;
  case 7:
    m_modalResult = mrNo;
    COleControl::SetText("No");
    break;
  case 8:
    m_modalResult = mrOn;
    COleControl::SetText("On");
    break;
  case 9:
    m_modalResult = mrOff;
    COleControl::SetText("Off");
  }

  //Set the OnOff property to false since the user selected another type.
  m_onOff = FALSE;

  //Set the modified flag.
  SetModifiedFlag();
}

void CPButtonCtrl::OnClick(USHORT iButton) 
{
  // See if the OnOff flag is set.  If so, change the caption and internal
  // caption flag.  The effect you should see from this code is a toggling
  // of the caption text.
  if (m_onOff)
  {
    if (m_SetOn)
    {
      COleControl::SetText("Off");
      m_SetOn = FALSE;
      m_modalResult = mrOff;
    }
    else
    {
      COleControl::SetText("On");
      m_SetOn = TRUE;
      m_modalResult = mrOn;
    }
  }

  // Call the default OnClick processing.
  COleControl::OnClick(iButton);
}

void CPButtonCtrl::OnIconTypeChanged() 
{
   // Paint the control.
   COleControl::Refresh();

   // Perform default action.
   SetModifiedFlag();
}

void CPButtonCtrl::OnIconPositionChanged() 
{
   // Paint the control.
   COleControl::Refresh();

   // Perform default action.
   SetModifiedFlag();
}

void CPButtonCtrl::OnMouseMove(UINT nFlags, CPoint point) 
{
   HICON   hIcon;   // Handle of the icon we'll display.
   CDC*   pdc;      //device context
   int   iWidth;  // Control Width
   int   iHeight; // Control Height

   // Get the control width and height.
   COleControl::GetControlSize(&iWidth, &iHeight);

   // Calculate the right position of the icon.
   iWidth -= 36;

   // Get the current device context.
   pdc = COleControl::GetDC(NULL, 0);
   
   // Load the requested bitmap.
   switch (m_iconType)
   {
   case 1:
      hIcon = LoadIcon(NULL, IDI_APPLICATION);
      break;
   case 2:
      hIcon = LoadIcon(NULL, IDI_HAND);
      break;
   case 3:
      hIcon = LoadIcon(NULL, IDI_QUESTION);
       break;
    case 4:
       hIcon = LoadIcon(NULL, IDI_EXCLAMATION);
       break;
    case 5:
       hIcon = LoadIcon(NULL, IDI_ASTERISK);
       break;
    case 6:
       hIcon = LoadIcon(NULL, IDI_WINLOGO);
       break;
    case 7:
       hIcon = LoadIcon(NULL, IDI_WARNING);
       break;
    case 8:
       hIcon = LoadIcon(NULL, IDI_ERROR);
       break;
    case 9:
       hIcon = LoadIcon(NULL, IDI_INFORMATION);
   }

   // Display the icon on screen.
   if (m_iconPosition == 0)
   {
      DrawIcon(pdc->m_hDC, 4, 4, hIcon);
   }
   else
   {
      DrawIcon(pdc->m_hDC, iWidth, 4, hIcon);
   }

   // Release the device context.
   COleControl::ReleaseDC(pdc);

   // Perform the default action.   
   COleControl::OnMouseMove(nFlags, point);
}
